(function () {
    // Attributes

    const colorInputs = [];
    let customProperties = null;

    /**
    * * Save config for the chart.
    */
    const saveCustomProperty = () => {
        window.parent.window.postMessage({ messageType: 'customWidget_saveCustomProperty', customPropertyValue: createConfigObject() }, '*');
        console.log('Called, customWidget_saveCustomProperty');
    }

    /**
     * *Validate the object for config and return with it.
     * TODO turnery
     */
    const validatingConfig = (isValidConfig, selectedLabelsElement, selectedDataElement, colors) => {
        return (isValidConfig) ? { selectedLabelsElement, selectedDataElement, colors } : null;
    }

    /**
     * *Create the object for config
     */
    const createConfigObject = () => {
        const selectedDataElement = document.querySelector('#Data').value;
        const selectedLabelsElement = document.querySelector('#Labels').value;
        const colors = [];
        let isValidConfig = true;

        colorInputs.forEach((colorInputs) => {
            if (colorInputs.value) {
                colors.push(colorInputs.value);
            } else {
                isValidConfig = false;
            }
        });

        return validatingConfig(isValidConfig, selectedLabelsElement, selectedDataElement, colors);
    };

    /**
     * * Here, we create as many items as we need for data.
     */
    const createSettingsItem = (value, color, title) => {
        const rowDiv = document.createElement('div');
        const titleDiv = document.createElement('div');
        const valueDiv = document.createElement('div');

        const titleLabel = document.createElement('label');
        const titleValue = document.createElement('div');

        const valueLabel = document.createElement('label');
        const valueValue = document.createElement('div');
        const colorInput = document.createElement('input');

        rowDiv.className = 'row';

        titleLabel.innerText = `Title:`;
        titleValue.innerText = title;

        valueLabel.innerText = `Value:`;
        valueValue.innerText = value;

        colorInput.type = 'color';
        colorInput.value = color;

        rowDiv.appendChild(titleDiv);
        rowDiv.appendChild(valueDiv);

        titleDiv.appendChild(titleLabel);
        titleDiv.appendChild(titleValue);

        valueDiv.appendChild(valueLabel);
        valueDiv.appendChild(valueValue);

        valueDiv.appendChild(colorInput);

        colorInputs.push(colorInput);

        return rowDiv;
    }

    /**
        * * Here, we remove all the children to reload them later.
    */
    const removeChildForRefresh = (settingsContainer) => {
        const childNodes = settingsContainer.childNodes;
        if (childNodes.length !== null) {
            const childLength = childNodes.length;
            for (let i = 0; i < childLength; i++) {
                settingsContainer.removeChild(childNodes[0]);
            }
        }
    }

    /**
        * * Here, we fill the field with our data.
    */
    const fillFieldWithData = (dataset, datasetConfig, selectedDataElement, selectedLabelsElement, settingsContainer) => {
        for (let i = 0; i < dataset.length; i++) {
            const settingsItem = createSettingsItem(
                dataset[i][selectedDataElement],
                (datasetConfig && datasetConfig.colors && datasetConfig.colors[i])
                    ? datasetConfig.colors[i]
                    : `#${Math.floor(Math.random() * 16777215).toString(16)}`,
                dataset[i][selectedLabelsElement]
            );
            settingsContainer.appendChild(settingsItem);
        }
    }

    /**
        * * Here, we load our data.
    */
    const reloadSelectedData = () => {
        const settingsContainer = document.querySelector('.settings-container');
        const selectedLabelsElement = document.querySelector('#Labels').value;
        const selectedDataElement = document.querySelector('#Data').value;
        let dataset = customProperties.dataset2; //! VÁLTOZÁS TÖRTÉNT
        let datasetConfig = customProperties.datasetConfig2;  //! VÁLTOZÁS TÖRTÉNT
        removeChildForRefresh(settingsContainer);
        fillFieldWithData(dataset, datasetConfig, selectedDataElement, selectedLabelsElement, settingsContainer);
    }

    /**
        * * Fill select options with Labels data 
    */
    const fillSelectWithLabels = (customProperties) => {
        Object.keys(customProperties.dataset2[0]).forEach(key => {   //! VÁLTOZÁS TÖRTÉNT
            let select = document.getElementById("Labels");
            let option = document.createElement("option");
            option.text = key;
            option.value = key;
            select.add(option);
        });
    }

    /**
        * * Fill select options with Value data 
    */
    const fillSelectWithValues = (customProperties) => {
        Object.keys(customProperties.dataset2[0]).forEach(key => {  //! VÁLTOZÁS TÖRTÉNT
            let select = document.getElementById("Data");
            let option = document.createElement("option");
            option.text = key;
            option.value = key;
            select.add(option);
        });
    }
    /**
        * *Load dataset with the selected data
    */
    const loadDatasetWithSelectedData = (customProperties, selectedLabelsElement, selectedDataElement) => {
        if (customProperties.datasetConfig2.selectedDataElement) { //! VÁLTOZÁS TÖRTÉNT
            selectedDataElement.value = customProperties.datasetConfig2.selectedDataElement; //! VÁLTOZÁS TÖRTÉNT
            selectedLabelsElement.value = customProperties.datasetConfig2.selectedLabelsElement; //! VÁLTOZÁS TÖRTÉNT
            reloadSelectedData();
        }
    }

    /**
        * * Init all data onload.
    */
    const initDataset = (event) => {
        customProperties = event.data.customProperties;
        const selectedLabelsElement = document.querySelector('#Labels');
        const selectedDataElement = document.querySelector('#Data');
        if (event.data.messageType === 'customWidget_sendCustomProperties' && customProperties && customProperties.dataset2) { //! VÁLTOZÁS TÖRTÉNT
            fillSelectWithLabels(customProperties);
            fillSelectWithValues(customProperties);
            loadDatasetWithSelectedData(customProperties, selectedLabelsElement, selectedDataElement);
        }
    }

    //Listeners
    window.addEventListener('message', initDataset);

    /**
     * *Get some functions to call them on HTML
     */
    const bindListenersToUi = () => {
        console.log('Init functions');
        document.getElementById("save").onclick = function () { saveCustomProperty(); }
        document.getElementById("Labels").onchange = function () { reloadSelectedData(); }
        document.getElementById("Data").onchange = function () { reloadSelectedData(); }
    }

    window.onload = () => {
        console.log("Onload!");
        bindListenersToUi();
        window.parent.window.postMessage({ messageType: 'customWidget_requestCurrentValue' }, '*');
        window.parent.window.postMessage({ messageType: 'customWidget_requestCustomProperties' }, '*');
        console.log('Called, customWidget_requestCurrentValue');
    };
}());